#define HAVE_LONG_LONG 1
/* * This file was generated by SLIRP, the (Sl)ang (I)nte(r)face (P)ackage,
 * a S-Lang module code generator for C, C++, and FORTRAN.
 *
 * Copyright (C) 2003-2009 Massachusetts Institute of Technology 
 * Copyright (C) 2002 Michael S. Noble <mnoble@space.mit.edu>
 *
 * SLIRP is free software, and may be used under the conditions stipulated
 * in the COPYRIGHT agreement bundled within the SLIRP distribution.
 */
#include <stdlib.h>		/* SLIRP common {{{ */
#include <unistd.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <slang.h>

#include <gtk/gtk.h>
#include <gtkdatabox.h>
#include <gtkdatabox_grid.h>
#include <gtkdatabox_markers.h>
#include <gtkdatabox_cross_simple.h>
#include <gtkdatabox_lines.h>
#include <gtkdatabox_bars.h>
#include <gtkdatabox_points.h>
#include <gtkdatabox_regions.h>
#include <gtkdatabox_offset_bars.h>
#include "module.h"

#define SAFE_DEREF_OPAQUE(po)		(po == NULL ? NULL : po->instance)
#define SAFE_DEREF_ARRAY(pa)		(pa == NULL ? NULL : pa->data)
#define SLang_pop_array(x)		SLang_pop_array(x, 1)
#define SLang_pop_string(x)             ( (SLang_peek_at_stack() == SLANG_NULL_TYPE && (SLdo_pop() || 1)) ? ((*x = NULL) || 1): SLang_pop_slstring(x))
#define SLang_push_size_t		SLang_push_uint
#define SLang_push_ptrdiff_t		SLang_push_int

#define pop_defaultable(argno, kind, type, obj, value) \
   (SLang_Num_Function_Args >= argno ? SLang_pop_##kind ( (type*)&obj) : ((obj = value) || ( (void*)&obj > (void*)0) ) )

#ifdef __cplusplus
#define LINKAGE "C"
#else
#define LINKAGE
#endif

#define USAGE(msg) \
    {SLang_verror(SL_USAGE_ERROR, (char*)"Usage: %s", msg); return;}

static void Slirp_usage(int i, int j, int flags);

static int slang_abi_mismatch(void)
{
   long module_abi = SLANG_VERSION / 10000;
   long app_abi    = SLang_Version / 10000;

   if (module_abi != app_abi) {
	SLang_verror(SL_APPLICATION_ERROR, (char*)
		"S-Lang library abi mismatch\nmodule: %s, application: %s",
		SLANG_VERSION_STRING, SLang_Version_String);
	return 1;
   }
			        
   return 0;
} /* }}} */

static char *slns;  /* slang namespace active at time of module load */
#define BEGIN_DECLS
#define END_DECLS
extern SLtype GtkOpaque_Type;
extern SLtype GObject_Type;
extern SLtype GdkDrawable_Type;
extern SLtype GdkPixmap_Type;
extern SLtype GdkBitmap_Type;
extern SLtype GdkGC_Type;
extern SLtype GdkPixbuf_Type;
extern SLtype GdkPixbufAnimation_Type;
extern SLtype GtkObject_Type;
extern SLtype GtkCellRenderer_Type;
extern SLtype GtkCellRendererPixbuf_Type;
extern SLtype GtkCellRendererText_Type;
extern SLtype GtkCellRendererToggle_Type;
extern SLtype GtkItemFactory_Type;
extern SLtype GtkTreeViewColumn_Type;
extern SLtype GtkTooltips_Type;
extern SLtype GtkAdjustment_Type;
extern SLtype GtkWidget_Type;
extern SLtype GdkCursor_Type;
extern SLtype GdkRegion_Type;
extern SLtype GtkIconSource_Type;
extern SLtype GtkIconSet_Type;
extern SLtype GtkTreeIter_Type;
extern SLtype GtkTextIter_Type;
extern SLtype GtkTreePath_Type;
#define SLIRP_EXTERN	extern
BEGIN_DECLS				/* Opaque handling code {{{ */

#define SLIRP_ABI_VERSION			10500

typedef void            (*FINALIZER)            (void*);
typedef void            (*INITIALIZER)          (void*);

typedef struct _Slirp_Type {
   SLang_Class_Type	*slclass;	/* SLang type class for this type */
   struct _Slirp_Type	*parent;	/* NULL if type has no ancestors  */
   FINALIZER		finalizer;
   INITIALIZER		initializer;
} Slirp_Type;

typedef struct _Slirp_Opaque {
   Slirp_Type *type;
   SLang_MMT_Type *mmt;
   void* instance;
   int deletion_in_progress;
   int free_me_too;		       /* if non-zero, free MMT, then struct */
   int owns_ref;		       /* if non-zero, do not free instance */
} Slirp_Opaque;

static void SLang_free_opaque (Slirp_Opaque *o)
{
   SLang_MMT_Type *mmt;

   if ((o == NULL)
       || (o->deletion_in_progress))
     return;

   mmt = o->mmt;
   if (mmt == NULL)
     return;

   o->mmt = NULL;
   o->deletion_in_progress = 1;
   SLang_free_mmt (mmt);
   o->deletion_in_progress = 0;
   if (o->free_me_too)
     SLfree ((char *) o);
}


static int opaque_typecast (SLtype from_type, VOID_STAR from_p,
			unsigned int num, SLtype to_type, VOID_STAR to_p)
{
   unsigned int i;
   SLang_MMT_Type **from = (SLang_MMT_Type**)from_p;
   SLang_MMT_Type **to   = (SLang_MMT_Type**)to_p;

   (void) from_type; (void) to_type; 

   for (i=0; i < num; i++) {
	to[i] = from[i];	/* FIXME: typeof() still reports prev type */
	if (from[i] != NULL)
	   SLang_inc_mmt(from[i]);
   }

   return 1;
}

static int opaque_search(const void* key, const void *elem)
{
   return *(SLtype*)key - SLclass_get_class_id((*(Slirp_Type**)elem)->slclass);
}

static void destroy_opaque(SLtype type, VOID_STAR w)
{
   Slirp_Opaque *ot = (Slirp_Opaque*)w;

   (void) type;

   if ((ot->type != NULL)
       && (ot->type->finalizer != NULL)
       && (ot->instance != NULL))
     {
	if (ot->owns_ref == 0)
	  (*ot->type->finalizer) (ot->instance);
	ot->instance = NULL;
     }

   if (ot->deletion_in_progress)
     {
	/* Evidently, the MMT container is being destroyed from SLang_free_mmt.
	 * Let it perform the final free.
	 */
	ot->free_me_too = 1;
	return;
     }
   SLfree( (char*)ot );
}
END_DECLS

SLIRP_EXTERN SLtype void_ptr_Type;	/* These opaque pointer types must */
SLIRP_EXTERN SLtype string_ptr_Type;	/* be kept in sync with opaques.c  */
SLIRP_EXTERN SLtype uchar_ptr_Type;
SLIRP_EXTERN SLtype short_ptr_Type;
SLIRP_EXTERN SLtype ushort_ptr_Type;
SLIRP_EXTERN SLtype int_ptr_Type;
SLIRP_EXTERN SLtype uint_ptr_Type;
SLIRP_EXTERN SLtype long_ptr_Type;
SLIRP_EXTERN SLtype ulong_ptr_Type;
SLIRP_EXTERN SLtype float_ptr_Type;
SLIRP_EXTERN SLtype double_ptr_Type;
SLIRP_EXTERN SLtype opaque_ptr_Type;
SLIRP_EXTERN SLtype file_ptr_Type;

typedef struct _Reserved_Opaque_Type {
   char	  *name;
   SLtype *type;		/* SLtype of opaque pointer defined by this */
   SLtype masked_type;		/* SLtype of datum to which this points */
} Reserved_Opaque_Type;

SLIRP_EXTERN Slirp_Type	**Slirp_Opaque_Types;
SLIRP_EXTERN SLtype 	Slirp_Num_Opaque_Types;
SLIRP_EXTERN SLtype	First_Opaque_Type;
SLIRP_EXTERN SLtype	Last_Reserved_Opaque_Type;

static Reserved_Opaque_Type Reserved_Opaque_Types[] = {

   { (char*)"void_ptr",		&void_ptr_Type,		SLANG_ANY_TYPE,    },
   { (char*)"int_ptr",		&int_ptr_Type,		SLANG_INT_TYPE,    },
   { (char*)"double_ptr",	&double_ptr_Type,	SLANG_DOUBLE_TYPE, },
   { (char*)"opaque_ptr",	&opaque_ptr_Type,	SLANG_ANY_TYPE,	   },
   { (char*)"file_ptr",		&file_ptr_Type,		SLANG_FILE_PTR_TYPE,},
   { (char*)"float_ptr",	&float_ptr_Type,	SLANG_FLOAT_TYPE,  },
   { (char*)"long_ptr",		&long_ptr_Type,		SLANG_LONG_TYPE,   },
   { (char*)"string_ptr",	&string_ptr_Type,	SLANG_STRING_TYPE, },
   { (char*)"uint_ptr",		&uint_ptr_Type,		SLANG_UINT_TYPE,   },
   { (char*)"short_ptr",	&short_ptr_Type,	SLANG_SHORT_TYPE,  },
   { (char*)"ulong_ptr",	&ulong_ptr_Type,	SLANG_ULONG_TYPE,  },
   { (char*)"ushort_ptr",	&ushort_ptr_Type,	SLANG_USHORT_TYPE, },
   { (char*)"uchar_ptr",	&uchar_ptr_Type,	SLANG_UCHAR_TYPE,  },
   { NULL, NULL, 0, }
};

#define NUM_RESERVED_OPAQUES \
	sizeof(Reserved_Opaque_Types) / sizeof(Reserved_Opaque_Type) - 1

static Slirp_Type* sltype_to_slirp_type(SLtype sltype)
{
   Slirp_Type **ot = (Slirp_Type**) bsearch( (const void*) &sltype,
	 		(const void*) Slirp_Opaque_Types,
			(size_t) Slirp_Num_Opaque_Types,
			sizeof(Slirp_Type*), opaque_search);

   if (ot != NULL) return *ot;
   return NULL;
}

static SLang_MMT_Type*
create_opaque_mmt(SLtype type, void *instance, unsigned int owns_ref)
{
   SLang_MMT_Type *mmt = NULL;
   Slirp_Opaque *ot = (Slirp_Opaque*) SLcalloc(1, sizeof(Slirp_Opaque));

   if (ot != NULL) {

	ot->instance = instance;
	ot->owns_ref = owns_ref;
	ot->mmt      = NULL;

	if ( (ot->type = sltype_to_slirp_type(type)) != NULL) {

	   if (ot->type->initializer != NULL)
		(*ot->type->initializer) (ot->instance);

	   mmt = SLang_create_mmt (type, (VOID_STAR) ot);
	}

	if (mmt == NULL)
	   SLfree((char*)ot);
   }

   return mmt;
}

static int SLang_push_opaque(SLtype type, void *instance, unsigned int owns_ref)
{
   SLang_MMT_Type *mmt;

   if (instance == NULL)
      return SLang_push_null();

   mmt = create_opaque_mmt(type, instance, owns_ref);
   if (NULL == mmt)
      return -1;

   if (-1 == SLang_push_mmt (mmt))
     {
	SLang_free_mmt (mmt);
	return -1;
     }
   return 0;
}

static int SLang_pop_opaque (SLtype type, void **instance, Slirp_Opaque **o)
{
   Slirp_Opaque *ot;
   SLang_MMT_Type *mmt = NULL;

   if (instance != NULL) *instance = NULL;
   *o = NULL;

   if ((type == file_ptr_Type)
       && (SLang_peek_at_stack() == SLANG_FILE_PTR_TYPE))
     {
	FILE *fp;
	if (-1 == SLang_pop_fileptr(&mmt, &fp))
	  return -1;

	ot = (Slirp_Opaque*) SLcalloc(1, sizeof(Slirp_Opaque));
	if (ot == NULL)
	  {
	     SLang_free_mmt(mmt);
	     return -1;
	  }
	ot->mmt = mmt;
	ot->free_me_too = 1;
	*instance = (void*)fp;
	*o = ot;
	return 0;
   }

   if (NULL == (mmt = SLang_pop_mmt (type)))
     return -1;

   if (NULL == (ot = (Slirp_Opaque*) SLang_object_from_mmt (mmt))
       || (ot->instance == NULL))
     {
	SLang_verror (SL_INVALID_PARM, "slirp: pop_opaque: instance=NULL");
	SLang_free_mmt (mmt);
	return -1;
     }

   /* This creates a circular reference:
    *    mmt->ot->mmt
    */
   ot->mmt = mmt;
   if (instance != NULL)
     *instance = ot->instance;
   *o = ot;
   return 0;
}

static unsigned int
allocate_opaque(char *name, FINALIZER fzer, INITIALIZER izer, SLtype parent_id,
		int (*sget)(SLtype, char *), int (*sput)(SLtype, char *))
{
   /* Returning from here with anything but a positive id is fatal */
   SLtype new_type, ancestor_type;
   Slirp_Type *type , *parent = NULL;
   SLang_Class_Type *new_class = SLclass_allocate_class (name);

   if (new_class == NULL) return SLANG_UNDEFINED_TYPE;

   (void) SLclass_set_destroy_function (new_class, destroy_opaque);
   if (-1 == SLclass_register_class (new_class, SLANG_VOID_TYPE,
				     sizeof(Slirp_Opaque),
				     SLANG_CLASS_TYPE_MMT))
	return SLANG_UNDEFINED_TYPE;

   new_type = SLclass_get_class_id(new_class);
   if (parent_id) {

	type = parent = sltype_to_slirp_type(parent_id);

	while (type) {

	   ancestor_type = SLclass_get_class_id(type->slclass);

	   /* Support downcasting ancestor types to this type */
	   if (-1 == SLclass_add_typecast (ancestor_type, new_type,
		    					opaque_typecast, 1))
		return SLANG_UNDEFINED_TYPE;

	   /* Support upcasting this type to each ancestor type */
	   if (-1 == SLclass_add_typecast (new_type, ancestor_type,
							opaque_typecast, 1))
		return SLANG_UNDEFINED_TYPE;

	   type = type->parent;
	}
   }

   if ( (sget != NULL && SLclass_set_sget_function(new_class, sget) == -1) ||
	(sput != NULL && SLclass_set_sput_function(new_class, sput) == -1))
	return SLANG_UNDEFINED_TYPE;
	
   if ( (type = (Slirp_Type*) SLmalloc(sizeof(Slirp_Type))) == NULL)
	return SLANG_UNDEFINED_TYPE;

   type->slclass = new_class;
   type->parent = parent;
   type->finalizer = fzer;
   type->initializer = izer;
   Slirp_Opaque_Types[ Slirp_Num_Opaque_Types++ ] = type;

   return new_type;
}

static int allocate_reserved_opaque_types(void)
{
   Reserved_Opaque_Type *pt;
   long abi_version = -1;

   if ( SLang_is_defined((char*)"_slirp_initialized")) {

	if ( SLang_is_defined((char*)"_slirp_abi_version") == 0  ||
		SLang_load_string((char*)"_slirp_abi_version;") == -1 ||
		SLang_pop_long(&abi_version) == -1 ||
		abi_version != SLIRP_ABI_VERSION)
	{
	   SLang_verror(SL_APPLICATION_ERROR,
		(char*) "SLIRP abi mismatch: want version %ld, have %ld\n",
		(long)SLIRP_ABI_VERSION, abi_version);
	   return -1;
	}

	return 0;
   }

   (void)SLang_load_string((char*)"public variable _slirp_initialized=1;");
   (void)SLang_push_int(SLIRP_ABI_VERSION);
   (void)SLang_load_string((char*)"public variable _slirp_abi_version=();");

   Slirp_Num_Opaque_Types = 0;

   if ( NULL == (Slirp_Opaque_Types = (Slirp_Type**) SLmalloc
			( sizeof(Slirp_Type*) * (NUM_RESERVED_OPAQUES + 1))))
      return -1;

   Slirp_Opaque_Types[0] = NULL;

   pt = Reserved_Opaque_Types;
   while (pt->name != NULL) {
	if ((*pt->type = allocate_opaque(pt->name, NULL,NULL,0,NULL,NULL)) ==
	      						SLANG_UNDEFINED_TYPE)
		return -1;
	   pt++;
	}

   /* Loop again, to enable casts to/from generic pointer type */
   pt = Reserved_Opaque_Types + 1;
   while (pt->name != NULL) {

	if (-1 == SLclass_add_typecast (*pt->type, void_ptr_Type,
							opaque_typecast, 1))
	   return SLANG_UNDEFINED_TYPE;

	if (-1 == SLclass_add_typecast (void_ptr_Type, *pt->type,
							opaque_typecast, 1))
	   return SLANG_UNDEFINED_TYPE;

	pt++;
   }

   First_Opaque_Type = *Reserved_Opaque_Types[0].type;
   Last_Reserved_Opaque_Type = First_Opaque_Type + NUM_RESERVED_OPAQUES - 1;

   return 0;
} /* }}} */
static int pop_nullable(SLtype type, void **obj, void **meta)
{
   if (SLANG_NULL_TYPE == SLang_peek_at_stack ()) { 
	*obj = NULL;
	if (type && meta != NULL)
	   *meta = NULL;
	return SLang_pop_null ();
   }

   switch(type) {

	case 0:
	   return SLang_pop_cstruct(*obj, (SLang_CStruct_Field_Type *)meta);

	case SLANG_ANY_TYPE:
	   return SLang_pop_anytype((SLang_Any_Type**)obj);

	case SLANG_REF_TYPE:
	   return SLang_pop_ref((SLang_Ref_Type**)obj);

	case SLANG_STRING_TYPE:
	   return SLang_pop_slstring ((char**)obj);

	default:
	   /* This will fail, as intended, for non-opaque types */
	   return SLang_pop_opaque(type, meta, (Slirp_Opaque**)obj);
   }
}
#define pop_string_or_null(s)  pop_nullable(SLANG_STRING_TYPE,(void**)s,NULL)
#define pop_ref_or_null(r)  pop_nullable(SLANG_REF_TYPE,(void**)&r->ref,r->data)
#define pop_anytype_or_null(a) pop_nullable(SLANG_ANY_TYPE,(void**)a,NULL)
static unsigned char map_scalars_to_refs = 0;

typedef struct _Slirp_Ref {			/* Ref handling code {{{ */
#define	REF_FLAG_FREE_DATA			0x01
#define	REF_FLAG_IS_OPAQUE			0x02
#define	REF_FLAG_COLUMN_MAJOR			0x04
#define	REF_FLAG_ARRAY_EXPECTED			0x08
   unsigned int		flags;		/* Slirp_Ref encapsulates S-Lang    */
   SLtype		sltype;		/* array, ref, and MMT types, the   */
   size_t		sizeof_type;	/* latter two of which are seen as  */
   void			**data;		/* pointing to a single object      */
   unsigned int		vstride;	/* how to find "next" vectored elem */
   SLang_Array_Type	*array;
   SLang_Ref_Type	*ref;
   SLang_MMT_Type	*mmt;		/* mmt supports passing around C    */
} Slirp_Ref;				/* ptr arrays of indeterminate size */

static Slirp_Ref* ref_new(SLtype t,size_t typesize, void *d,unsigned int flags)
{
   Slirp_Ref *ref;
   if ((ref = (Slirp_Ref*)SLcalloc( sizeof(Slirp_Ref), 1)) != NULL) {
	ref->sltype = t;
	ref->sizeof_type = typesize;
	ref->flags = flags;
	ref->data = (void**)d;
	*ref->data = NULL;
   }
   return ref;
}

static int ref_finalize(Slirp_Ref *r) /* {{{ */
{
   int status = 0;
   if (r == NULL) return 0;

   if (r->ref) {

        void *ref_value = NULL; SLtype ref_type = 0; double dc[2];

	if (r->flags & REF_FLAG_IS_OPAQUE) { 	/* wrap aggregates/opaques  */
#ifdef NUM_RESERVED_OPAQUES			/* in mmt before ref assign */
	   void *opaqval = *r->data;		/* the mmt w/be freed when  */
	   if (opaqval == NULL) {		/* the S-Lang object goes   */
		ref_value = NULL;		/* out of scope		    */
		ref_type = SLANG_NULL_TYPE;
	   }
	   else {
		SLang_MMT_Type *mmt = create_opaque_mmt(r->sltype, opaqval, 0);
		ref_value = &mmt;
		ref_type = r->sltype;
	   }
#endif
	}
	else {
	   ref_type = r->sltype;
	   if (ref_type == SLANG_COMPLEX_TYPE && r->sizeof_type < sizeof(dc)) {
		float *fc = (float*) r->data;
		dc[0] = fc[0];
		dc[1] = fc[1];
		ref_value = dc;
	   }
	   else
		ref_value = r->data;
	}

	status = SLang_assign_to_ref (r->ref, ref_type, ref_value);
	SLang_free_ref(r->ref);
   }
   else if (r->array) {
#ifdef HAVE_FORTRAN_CODE
	if ((r->flags & REF_FLAG_COLUMN_MAJOR) && TRANSPOSE(1,r->array) == -1)
		return -1;
#endif
	SLang_free_array(r->array);
   }
   else if (r->mmt)
	SLang_free_mmt(r->mmt);

   if (r->flags & REF_FLAG_FREE_DATA)
	SLfree( (char*) r->data );

   SLfree((char*)r);
   return status;
} /* }}} */

static void finalize_refs(unsigned int nargs, ...) /* {{{ */
{
   va_list ap;
   va_start(ap, nargs);
   while (nargs--) ref_finalize(va_arg(ap, Slirp_Ref *));
   va_end(ap);
} /* }}} */

static unsigned int ref_get_size(Slirp_Ref *r, int which_dimension) /* {{{ */
{
   if (r->array) {
	if (which_dimension == 0)
	   return (unsigned int)r->array->num_elements;
	else if (which_dimension < 0)
	   return r->array->num_dims;
	else {
	   which_dimension--;
	   if ((unsigned int)which_dimension < r->array->num_dims)
		return (unsigned int)r->array->dims[which_dimension];
	   else
		return 0;
	}
   }

   return 1;
} /* }}} */

extern LINKAGE int _SLang_get_class_type (SLtype t);	/* quasi-public  */

#ifdef NUM_RESERVED_OPAQUES
static SLtype sltype_to_opaque_ptr_type(SLtype sltype) /*{{{*/
{
   Reserved_Opaque_Type *pt;

   if (sltype > Last_Reserved_Opaque_Type) return opaque_ptr_Type;
   if (sltype == void_ptr_Type) return void_ptr_Type;

   pt = Reserved_Opaque_Types;		/* sequential search, but s/b < O(n) */
   while (pt->name) {			/* since list is ordered by expected */
	if (pt->masked_type == sltype)	/* frequency of use for each SLtype  */
	   return *pt->type;		
	pt++;
   }
   return 0;
} /*}}}*/
#endif

static int try_pop_mmt(SLtype type, SLang_MMT_Type **mmt) /*{{{*/
{
   static SLang_Name_Type *cl_type_func;	/* SLang_pop_mmt doesn't */
   int classtype;				/* validate that type is */
						/* an MMT, so we do here */
   *mmt = NULL;					/* FIXME: remove v2.0.7  */

   if (cl_type_func == NULL)
	cl_type_func = SLang_get_function( (char*) "__class_type");

   if (cl_type_func == NULL)
      return 0;

   if (-1 == SLang_push_datatype(type) ||		/* do the hard way, */
	-1 == SLexecute_function(cl_type_func) ||	/* as C api lacks   */
	-1 == SLang_pop_int(&classtype))		/* get_class_type() */
	return -1;

   if (classtype == SLANG_CLASS_TYPE_MMT) {
	*mmt = SLang_pop_mmt(type);
	return 1;
   }
   return 0;
} /*}}}*/

#define POP_FLAG_NULLABLE	0x1
#define POP_FLAG_VECTORIZE	0x2
static int pop_array_or_ref(Slirp_Ref *r, int flags, int defaultable) /*{{{*/
{
   SLtype type;
   unsigned int i, objtype;
#ifdef NUM_RESERVED_OPAQUES
   unsigned int is_opaque;
#endif

   if (r == NULL) {
	SLang_verror(SL_INTRINSIC_ERROR, (char*)"Attempted NULL reference (out of memory?)");
	return -1;
   }

   if (defaultable && SLang_Num_Function_Args < defaultable) {
	r->ref   = NULL;	/* observe that only NULL can be */
	*r->data = NULL;	/* assigned as the default value */
	return 0;
   }
   
   objtype = SLang_peek_at_stack();

   if ((flags & POP_FLAG_NULLABLE) && objtype == SLANG_NULL_TYPE) {
	r->ref   = NULL;		/* nullable flag: a pointer arg for */
	*r->data = NULL;		/* which NULL is a legitimate value */
	return SLang_pop_null ();
   }

   type = r->sltype;

#ifdef NUM_RESERVED_OPAQUES
   is_opaque =(type >= First_Opaque_Type && sltype_to_slirp_type(type) != NULL);
   if (is_opaque) r->flags |= REF_FLAG_IS_OPAQUE;
#endif

   switch(objtype) {

	case SLANG_ARRAY_TYPE:

	   if (SLang_pop_array_of_type(&r->array, type) == -1)
		return -1;

#ifdef HAVE_FORTRAN_CODE
	   if (r->flags & REF_FLAG_COLUMN_MAJOR) {
		if (flags & POP_FLAG_VECTORIZE)		/* vectorizable arrs*/
		   r->flags ^= REF_FLAG_COLUMN_MAJOR;   /* r not transposed */
		else if (TRANSPOSE(0,r->array) == -1)
		   return -1;
	   }
#endif

	   i = r->array->num_elements;
#ifdef NUM_RESERVED_OPAQUES
	   if (is_opaque) {
	      	Slirp_Opaque *ot;
		SLang_MMT_Type** mmts = (SLang_MMT_Type**)r->array->data;
		void **arr = (void**)SLmalloc(i * sizeof(void*) );
		if (arr == NULL) return -1;

		while (i--) {
		   ot = (Slirp_Opaque*) SLang_object_from_mmt (mmts[i]);
		   if (ot == NULL) {
			SLfree((char*)arr);
			return -1;
		   }
		   arr[i] = ot->instance;
		}

		*r->data = (void*)arr; r->data = (void**)arr;
		r->flags |= REF_FLAG_FREE_DATA;
	   }
	   else
#endif
	   if (type == SLANG_COMPLEX_TYPE &&
		 		r->sizeof_type < r->array->sizeof_type) {
		double *dc = (double*) r->array->data;
		float  *fc = (float *) SLmalloc(i * r->sizeof_type);
		if (fc == NULL) return -1;
		*r->data = fc; r->data = (void**)fc;
		while (i--) { *fc++ = (float) *dc++; *fc++ = (float) *dc++; }
		r->flags |= REF_FLAG_FREE_DATA;
	   }
	   else {
		*r->data = r->array->data;
		r->data = (void**)*r->data;
	   }

	   break;

	case SLANG_REF_TYPE:

	   /* Refs can only send values one-way (C to S-Lang, not reverse) */
	   if (SLang_pop_ref(&r->ref) == -1)
		return -1;

	   /* Ref is assumed to point to a scalar instance of the  */
	   /* refd type, so declare enough space to hold one such. */
	   *r->data = (void*)SLmalloc(r->sizeof_type);
	   if (*r->data == NULL) return -1;
	   memset(*r->data, 0, r->sizeof_type);
	   r->flags |= REF_FLAG_FREE_DATA;
	   r->data = (void**)*r->data;
	   break;

	/* Allow scalars to used as if they were 1-element arrays */
	case SLANG_CHAR_TYPE: case SLANG_UCHAR_TYPE:
	case SLANG_SHORT_TYPE: case SLANG_USHORT_TYPE:
	case SLANG_INT_TYPE: case SLANG_UINT_TYPE:
	case SLANG_LONG_TYPE: case SLANG_ULONG_TYPE:
	case SLANG_FLOAT_TYPE: case SLANG_DOUBLE_TYPE:
	case SLANG_COMPLEX_TYPE: case SLANG_STRING_TYPE:

	   /* Accomodate FORTRAN-style pass by reference semantics */
	   if (map_scalars_to_refs &&
		 	SLang_pop_array_of_type(&r->array,type) == 0) {

		*r->data = (void*)SLmalloc(r->sizeof_type);
		if (*r->data == NULL) return -1;

		if (r->sizeof_type == r->array->sizeof_type)
		   memcpy(*r->data, r->array->data, r->sizeof_type);
		else if (type == SLANG_COMPLEX_TYPE) {
		   double *dc = (double*) r->array->data;
		   float  *fc = (float*) *r->data;
		   fc[0] = (float)dc[0];
		   fc[1] = (float)dc[1];
		}
		else  {
		   SLang_verror(SL_TYPE_MISMATCH, (char*)
			"mismatched type sizes, when popping scalar as ref");
		   SLang_free_array(r->array);
		   return -1;
		}

		r->data = (void**)*r->data;
		r->flags |= REF_FLAG_FREE_DATA;
		/* Nullify to distinguish between vectored/non-vectored args */
		SLang_free_array(r->array); r->array = NULL;
		break;
	   }				/* intentional fallthrough */

	default:

#ifdef NUM_RESERVED_OPAQUES
	   if (objtype >= First_Opaque_Type && 
		 		sltype_to_slirp_type(objtype) != NULL) {

		if (!(flags & POP_FLAG_VECTORIZE))
		   type = sltype_to_opaque_ptr_type(type);

		if (type) {

		   Slirp_Opaque *otp;
		   if (SLang_pop_opaque(type, NULL, &otp) == -1)
			return -1;
		
		   if (flags & POP_FLAG_VECTORIZE) {
			void **arr = (void**) SLmalloc(sizeof(void*));
			if (arr == NULL) return -1;
			arr[0] = otp->instance;
			*r->data = arr;
			r->flags |= REF_FLAG_FREE_DATA;
		   }
		   else
			*r->data = otp->instance;

		   r->data = (void**)*r->data;
		   r->mmt = otp->mmt;
		   return 0;
		}
	   }
	   else
#endif
	   if ( try_pop_mmt(objtype, &r->mmt) == 1 &&
		(*r->data = SLang_object_from_mmt (r->mmt)) != NULL) {
		   r->data = (void**)*r->data;	 /* not flagged for freeing */
		   return 0;
	   }

	   SLang_verror(SL_TYPE_MISMATCH, (char*)
			"context requires array, ref, or opaque pointer");
	   return -1;
   }
   return 0;
} /*}}}*/
/* }}} */

/* Wrapper functions */ /* {{{ */
static void sl_gtk_databox_get_ruler_x (void)
{
   GtkDataboxRuler* retval;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_get_ruler_x(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (0, 0, 0);
}

static void sl_gtk_databox_get_enable_zoom (void)
{
   gboolean retval;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_get_enable_zoom(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1, 1, 0);
}

static void sl_gtk_databox_graph_get_hide (void)
{
   gboolean retval;
   GtkDataboxGraph* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_graph_get_hide(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2, 2, 0);
}

static void sl_gtk_databox_graph_get_gc (void)
{
   GdkGC* retval;
   GtkDataboxGraph* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_graph_get_gc(arg1);
   (void)SLang_push_opaque(GdkGC_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3, 3, 0);
}

static void sl_gtk_databox_set_scale_type_y (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkDataboxScaleType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_set_scale_type_y(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4, 4, 0);
}

static void sl_gtk_databox_grid_set_vlines (void)
{
   GtkDataboxGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_grid_set_vlines(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5, 5, 0);
}

static void sl_gtk_databox_get_visible_limits (void)
{
   gfloat l, r, t, b;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_get_visible_limits(arg1, &l, &r, &t, &b);
   (void)SLang_push_float(l);
   (void)SLang_push_float(r);
   (void)SLang_push_float(t);
   (void)SLang_push_float(b);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (6, 6, 0);
}

static void sl_gtk_databox_cross_simple_new (void)
{
   GtkDataboxGraph* retval;
   GdkColor* arg1 = (GdkColor*) alloca(sizeof(GdkColor));
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg1, GdkColor_Layout)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_cross_simple_new(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)arg1, GdkColor_Layout);
usage_label:
   if (issue_usage) Slirp_usage (7, 7, 0);
}

static void sl_gtk_databox_create_box_with_scrollbars_and_rulers (void)
{
   gboolean arg1, arg2, arg3, arg4;
   GtkWidget* databox;
   GtkWidget *table;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_databox_create_box_with_scrollbars_and_rulers (&databox, &table, arg1, arg2, arg3, arg4);
   SLang_push_opaque (GtkWidget_Type, (void*)databox, 0);
   SLang_push_opaque (GtkWidget_Type, (void*)table, 0);   
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (8, 8, 0);
}

static void sl_gtk_databox_set_adjustment_y (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkAdjustment_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_databox_set_adjustment_y(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (9, 9, 0);
}

static void sl_gtk_databox_grid_array_new (void)
{
   GtkDataboxGraph* retval;
   GdkColor *color = (GdkColor*) alloca(sizeof(GdkColor));
   SLang_Array_Type *x, *y;
   guint size;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&size)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)color, GdkColor_Layout)) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&y, SLANG_FLOAT_TYPE)) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&x, SLANG_FLOAT_TYPE)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_grid_array_new (x->dims [0], y->dims [0], x->data, y->data, color, size);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)color, GdkColor_Layout);
usage_label:
   if (issue_usage) Slirp_usage (10, 10, 0);
}

static void sl_gtk_databox_ruler_set_range (void)
{
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   gdouble arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_set_range(arg1,  arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (11, 11, 0);
}

static void sl_gtk_databox_value_to_pixel_x (void)
{
   gint16 retval;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_value_to_pixel_x(arg1,  arg2);
   (void)SLang_push_short(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (12, 12, 0);
}

static void sl_gtk_databox_get_enable_selection (void)
{
   gboolean retval;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_get_enable_selection(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (13, 13, 0);
}

static void sl_gtk_databox_graph_get_size (void)
{
   gint retval;
   GtkDataboxGraph* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_graph_get_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (14, 14, 0);
}

static void sl_gtk_databox_set_enable_zoom (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_set_enable_zoom(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (15, 15, 0);
}

static void sl_gtk_databox_graph_get_color (void)
{
   GdkColor* retval;
   GtkDataboxGraph* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_graph_get_color(arg1);
   (void)SLang_push_cstruct((VOID_STAR)retval,GdkColor_Layout);
   /* (void)SLang_push_struct(retval); */
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (16, 16, 0);
}

static void sl_gtk_databox_set_visible_limits (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   gfloat arg3;
   gfloat arg4;
   gfloat arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_set_visible_limits(arg1,  arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (17, 17, 0);
}

static void sl_gtk_databox_value_to_pixel_y (void)
{
   gint16 retval;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_value_to_pixel_y(arg1,  arg2);
   (void)SLang_push_short(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (18, 18, 0);
}

static void sl_gtk_databox_graph_calculate_extrema (void)
{
   gint retval;
   gfloat min_x, max_x, min_y, max_y;
   GtkDataboxGraph* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_graph_calculate_extrema(arg1, &min_x, &max_x, &min_y, &max_y);
   (void) SLang_push_float (min_x);
   (void) SLang_push_float (max_x);
   (void) SLang_push_float (min_y);
   (void) SLang_push_float (max_y);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (19, 19, 0);
}

static void sl_gtk_databox_zoom_out (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_zoom_out(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (20, 20, 0);
}

static void sl_gtk_databox_pixel_to_value_x (void)
{
   gfloat retval;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint16 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_short((short*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_pixel_to_value_x(arg1,  arg2);
   (void)SLang_push_float(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (21, 21, 0);
}

static void sl_gtk_databox_graph_remove_all (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_graph_remove_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (22, 22, 0);
}

static void sl_gtk_databox_get_scale_type_x (void)
{
   GtkDataboxScaleType retval;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_get_scale_type_x(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (23, 23, 0);
}

static void sl_gtk_databox_ruler_new (void)
{
   GtkWidget* retval;
   GtkOrientation arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_ruler_new( arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (24, 24, 0);
}

static void sl_gtk_databox_grid_get_vlines (void)
{
   gint retval;
   GtkDataboxGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_grid_get_vlines(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (25, 25, 0);
}

static void sl_gtk_databox_grid_new (void)
{
   GtkDataboxGraph* retval;
   gint arg1;
   gint arg2;
   GdkColor* arg3 = (GdkColor*) alloca(sizeof(GdkColor));
   guint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg3, GdkColor_Layout)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_int((int*)&arg1)) goto free_and_return_3;
   issue_usage = 0;

   retval = gtk_databox_grid_new( arg1,  arg2, arg3,  arg4);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_3:
   SLang_free_cstruct((VOID_STAR)arg3, GdkColor_Layout);
usage_label:
   if (issue_usage) Slirp_usage (26, 26, 0);
}

static void sl_gtk_databox_auto_rescale (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_auto_rescale(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (27, 27, 0);
}

static void sl_gtk_databox_ruler_set_orientation (void)
{
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkOrientation arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_set_orientation(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (28, 28, 0);
}

static void sl_gtk_databox_set_ruler_y (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkDataboxRuler* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_databox_set_ruler_y(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (29, 29, 0);
}

static void sl_gtk_databox_pixel_to_value_y (void)
{
   gfloat retval;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint16 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_short((short*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_pixel_to_value_y(arg1,  arg2);
   (void)SLang_push_float(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (30, 30, 0);
}

static void sl_gtk_databox_markers_set_label (void)
{
   GtkDataboxMarkers* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   GtkDataboxMarkersTextPosition arg3;
   gchar* arg4;
   gboolean arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_4;
   issue_usage = 0;

   gtk_databox_markers_set_label(arg1,  arg2,  arg3, arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (31, 31, 0);
}

static void sl_gtk_databox_ruler_get_range (void)
{
   gdouble l, u, p;
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_get_range(arg1, &l, &u, &p);
   (void) SLang_push_double (l);
   (void) SLang_push_double (u);
   (void) SLang_push_double (p);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (32, 32, 0);
}

static void sl_gtk_databox_get_adjustment_x (void)
{
   GtkAdjustment* retval;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_get_adjustment_x(arg1);
   (void)SLang_push_opaque(GtkAdjustment_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (33, 33, 0);
}

static void sl_gtk_databox_zoom_to_selection (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_zoom_to_selection(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (34, 34, 0);
}

static void sl_gtk_databox_create_box_with_scrollbars_and_rulers_positioned (void)
{
   gboolean arg1, arg2, arg3, arg4, arg5, arg6;
   GtkWidget* databox;
   GtkWidget *table;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_databox_create_box_with_scrollbars_and_rulers_positioned(&databox, &table, arg1, arg2, arg3, arg4, arg5, arg6);
   SLang_push_opaque (GtkWidget_Type, (void*)databox, 0);
   SLang_push_opaque (GtkWidget_Type, (void*)table, 0);   
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (35, 35, 0);
}

static void sl_gtk_databox_ruler_set_max_length (void)
{
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_set_max_length(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (36, 36, 0);
}

static void sl_gtk_databox_ruler_get_scale_type (void)
{
   GtkDataboxScaleType retval;
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_ruler_get_scale_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (37, 37, 0);
}

static void sl_gtk_databox_set_enable_selection (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_set_enable_selection(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (38, 38, 0);
}

static void sl_gtk_databox_set_adjustment_x (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkAdjustment_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_databox_set_adjustment_x(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (39, 39, 0);
}

static void sl_gtk_databox_graph_add (void)
{
   gboolean retval;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkDataboxGraph* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_databox_graph_add(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (40, 40, 0);
}

static void sl_gtk_databox_graph_set_color (void)
{
   GtkDataboxGraph* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkColor* arg2 = (GdkColor*) alloca(sizeof(GdkColor));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkColor_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_databox_graph_set_color(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkColor_Layout);
usage_label:
   if (issue_usage) Slirp_usage (41, 41, 0);
}

static void sl_gtk_databox_grid_set_hlines (void)
{
   GtkDataboxGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_grid_set_hlines(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (42, 42, 0);
}

static void sl_gtk_databox_markers_set_position (void)
{
   GtkDataboxMarkers* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   GtkDataboxMarkersPosition arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_markers_set_position(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (43, 43, 0);
}

static void sl_gtk_databox_calculate_extrema (void)
{
   gint retval;
   gfloat min_x, max_x, min_y, max_y;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_calculate_extrema(arg1, &min_x, &max_x, &min_y, &max_y);
   (void)SLang_push_float(min_x);
   (void)SLang_push_float(max_x);
   (void)SLang_push_float(min_y);
   (void)SLang_push_float(max_y);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (44, 44, 0);
}

static void sl_gtk_databox_get_total_limits (void)
{
   gfloat l, r, t, b;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_get_total_limits(arg1, &l, &r, &t, &b);
   (void)SLang_push_float(l);
   (void)SLang_push_float(r);
   (void)SLang_push_float(t);
   (void)SLang_push_float(b);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (45, 45, 0);
}

static void sl_gtk_databox_ruler_get_max_length (void)
{
   guint retval;
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_ruler_get_max_length(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (46, 46, 0);
}

static void sl_gtk_databox_ruler_get_orientation (void)
{
   GtkOrientation retval;
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_ruler_get_orientation(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (47, 47, 0);
}

static void sl_gtk_databox_markers_new (void)
{
   GtkDataboxGraph *retval;
   GdkColor *color = (GdkColor*) alloca(sizeof(GdkColor));
   SLang_Array_Type *x, *y;   
   guint size;
   GtkDataboxMarkersType type;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&type)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&size)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)color, GdkColor_Layout)) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&y, SLANG_FLOAT_TYPE)) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&x, SLANG_FLOAT_TYPE)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_markers_new (x->dims [0], x->data, y->data, color, size, type);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_4:
   SLang_free_cstruct((VOID_STAR)color, GdkColor_Layout);
usage_label:
   if (issue_usage) Slirp_usage (48, 48, 0);
}

static void sl_gtk_databox_graph_remove (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkDataboxGraph* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_databox_graph_remove(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (49, 49, 0);
}

static void sl_gtk_databox_graph_set_hide (void)
{
   GtkDataboxGraph* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_graph_set_hide(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (50, 50, 0);
}

static void sl_gtk_databox_ruler_set_scale_type (void)
{
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_set_scale_type(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (51, 51, 0);
}

static void sl_gtk_databox_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (52, 52, 0);
}

static void sl_gtk_databox_get_adjustment_y (void)
{
   GtkAdjustment* retval;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_get_adjustment_y(arg1);
   (void)SLang_push_opaque(GtkAdjustment_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (53, 53, 0);
}

static void sl_gtk_databox_get_ruler_y (void)
{
   GtkDataboxRuler* retval;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_get_ruler_y(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (54, 54, 0);
}

static void sl_gtk_databox_grid_get_hlines (void)
{
   gint retval;
   GtkDataboxGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_grid_get_hlines(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (55, 55, 0);
}

static void sl_gtk_databox_zoom_home (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_zoom_home(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (56, 56, 0);
}

static void sl_gtk_databox_set_ruler_x (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkDataboxRuler* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_databox_set_ruler_x(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (57, 57, 0);
}

static void sl_gtk_databox_graph_set_gc (void)
{
   GtkDataboxGraph* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkGC* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkGC_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_databox_graph_set_gc(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (58, 58, 0);
}

static void sl_gtk_databox_set_scale_type_x (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkDataboxScaleType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_set_scale_type_x(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (59, 59, 0);
}

static void sl_gtk_databox_graph_set_size (void)
{
   GtkDataboxGraph* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_graph_set_size(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (60, 60, 0);
}

static void sl_gtk_databox_get_scale_type_y (void)
{
   GtkDataboxScaleType retval;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_get_scale_type_y(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (61, 61, 0);
}

static void sl_gtk_databox_set_total_limits (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   gfloat arg3;
   gfloat arg4;
   gfloat arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_set_total_limits(arg1,  arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (62, 62, 0);
}

static void sl_gtk_databox_bars_new (void)
{
   GtkDataboxGraph *retval;
   GdkColor *color = (GdkColor*) alloca(sizeof(GdkColor));
   SLang_Array_Type *x, *y;   
   guint size;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&size)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)color, GdkColor_Layout)) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&y, SLANG_FLOAT_TYPE)) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&x, SLANG_FLOAT_TYPE)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_bars_new (x->dims [0], x->data, y->data, color, size);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)color, GdkColor_Layout);
usage_label:
   if (issue_usage) Slirp_usage (63, 63, 0);
}

static void sl_gtk_databox_lines_new (void)
{
   GtkDataboxGraph *retval;
   GdkColor *color = (GdkColor*) alloca(sizeof(GdkColor));
   SLang_Array_Type *x, *y;   
   guint size;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&size)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)color, GdkColor_Layout)) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&y, SLANG_FLOAT_TYPE)) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&x, SLANG_FLOAT_TYPE)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_lines_new (x->dims [0], x->data, y->data, color, size);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)color, GdkColor_Layout);
usage_label:
   if (issue_usage) Slirp_usage (64, 64, 0);
}

static void sl_gtk_databox_points_new (void)
{
   GtkDataboxGraph *retval;
   GdkColor *color = (GdkColor*) alloca(sizeof(GdkColor));
   SLang_Array_Type *x, *y;   
   guint size;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&size)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)color, GdkColor_Layout)) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&y, SLANG_FLOAT_TYPE)) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&x, SLANG_FLOAT_TYPE)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_points_new (x->dims [0], x->data, y->data, color, size);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)color, GdkColor_Layout);
usage_label:
   if (issue_usage) Slirp_usage (65, 65, 0);
}

static void sl_gtk_databox_graph_add_front (void)
{
   gboolean retval;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkDataboxGraph* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_databox_graph_add_front(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (66, 66, 0);
}

static void sl_gtk_databox_set_box_shadow (void)
{
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkShadowType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return;
   issue_usage = 0;

   gtk_databox_set_box_shadow (arg1, arg2);
   goto free_and_return;
free_and_return:
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (67, 67, 0);   
}

static void sl_gtk_databox_get_box_shadow (void)
{
   GtkShadowType retval;
   GtkDatabox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return;
   issue_usage = 0;

   retval = gtk_databox_get_box_shadow (arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (68, 68, 0);   
}

static void sl_gtk_databox_ruler_set_text_orientation (void)
{
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkOrientation arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_set_text_orientation(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (69, 69, 0);
}

static void sl_gtk_databox_ruler_get_text_orientation (void)
{
   GtkOrientation retval;
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_ruler_get_text_orientation(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (70, 70, 0);
}

static void sl_gtk_databox_ruler_set_text_alignment (void)
{
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkOrientation arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_set_text_alignment(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (71, 71, 0);
}

static void sl_gtk_databox_ruler_get_text_alignment (void)
{
   GtkOrientation retval;
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_ruler_get_text_alignment(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (72, 72, 0);
}




static void sl_gtk_databox_ruler_set_draw_ticks (void)
{
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_set_draw_ticks(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (73, 73, 0);
}

static void sl_gtk_databox_ruler_get_draw_ticks (void)
{
   gboolean retval;
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_ruler_get_draw_ticks(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (74, 74, 0);
}

static void sl_gtk_databox_ruler_set_draw_position (void)
{
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_set_draw_position(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (75, 75, 0);
}

static void sl_gtk_databox_ruler_get_draw_position (void)
{
   gboolean retval;
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_ruler_get_draw_position(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (76, 76, 0);
}

static void sl_gtk_databox_ruler_set_draw_subticks (void)
{
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_set_draw_subticks(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (77, 77, 0);
}

static void sl_gtk_databox_ruler_get_draw_subticks (void)
{
   gboolean retval;
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_ruler_get_draw_subticks(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (78, 78, 0);
}

static void sl_gtk_databox_ruler_set_text_hoffset (void)
{
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_set_text_hoffset(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (79, 79, 0);
}

static void sl_gtk_databox_ruler_get_text_hoffset (void)
{
   gint retval;
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_ruler_get_text_alignment(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (80, 80, 0);
}

static void sl_gtk_databox_ruler_set_invert_edge (void)
{
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_set_invert_edge(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (81, 81, 0);
}

static void sl_gtk_databox_ruler_get_invert_edge (void)
{
   gboolean retval;
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_ruler_get_invert_edge(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (82, 82, 0);
}

static void sl_gtk_databox_ruler_set_linear_label_format (void)
{
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar *arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_set_linear_label_format(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (83, 83, 0);
}

static void sl_gtk_databox_ruler_get_linear_label_format (void)
{
   gchar *retval;
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_ruler_get_linear_label_format(arg1);
   (void)SLang_push_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (84, 84, 0);
}

static void sl_gtk_databox_ruler_set_log_label_format (void)
{
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar *arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_set_log_label_format(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (85, 85, 0);
}

static void sl_gtk_databox_ruler_get_log_label_format (void)
{
   gchar *retval;
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_ruler_get_log_label_format(arg1);
   (void)SLang_push_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (86, 86, 0);
}

static void sl_gtk_databox_regions_new (void)
{
   GtkDataboxGraph *retval;
   GdkColor *color = (GdkColor*) alloca(sizeof(GdkColor));
   SLang_Array_Type *x, *y1, *y2;   
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)color, GdkColor_Layout)) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&y2, SLANG_FLOAT_TYPE)) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&y1, SLANG_FLOAT_TYPE)) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&x, SLANG_FLOAT_TYPE)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_regions_new (x->dims [0], x->data, y1->data, y2->data, color);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)color, GdkColor_Layout);
usage_label:
   if (issue_usage) Slirp_usage (87, 87, 0);
}

static void sl_gtk_databox_offset_bars_new (void)
{
   GtkDataboxGraph *retval;
   GdkColor *color = (GdkColor*) alloca(sizeof(GdkColor));
   SLang_Array_Type *x, *y1, *y2;   
   guint size;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&size)) goto usage_label;
   if (-1 == SLang_pop_cstruct ((VOID_STAR)color, GdkColor_Layout)) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&y2, SLANG_FLOAT_TYPE)) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&y1, SLANG_FLOAT_TYPE)) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&x, SLANG_FLOAT_TYPE)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_offset_bars_new (x->dims [0], x->data, y1->data, y2->data, color, size);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)color, GdkColor_Layout);
usage_label:
   if (issue_usage) Slirp_usage (87, 87, 0);
}

static void sl_gtk_databox_ruler_set_box_shadow (void)
{
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkShadowType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_set_box_shadow(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (88, 88, 0);
}

static void sl_gtk_databox_ruler_get_box_shadow (void)
{
   GtkShadowType retval;
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_databox_ruler_get_box_shadow(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (89, 89, 0);
}

static void sl_gtk_databox_ruler_set_manual_ticks (void)
{
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   SLang_Array_Type *ticks;
   gfloat arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&ticks, SLANG_FLOAT_TYPE)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_set_manual_tick_cnt (arg1, ticks->dims [0]);
   gtk_databox_ruler_set_manual_ticks(arg1, ticks->data);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (90, 90, 0);
}

static void sl_gtk_databox_ruler_get_manual_ticks (void)
{
   gfloat *retval;
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   SLang_Array_Type *ticks;
   SLindex_Type n;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;
   
   n = gtk_databox_ruler_get_manual_tick_cnt (arg1);
   retval = gtk_databox_ruler_get_manual_ticks(arg1);
   ticks = SLang_create_array (SLANG_FLOAT_TYPE, 0, retval, &n, 1);
   if (ticks == NULL)
     return;
   (void)SLang_push_array(ticks, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (91, 91, 0);
}

static void sl_gtk_databox_ruler_set_manual_tick_labels (void)
{
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   SLang_Array_Type *ticks;
   gfloat arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_array_of_type (&ticks, SLANG_STRING_TYPE)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_databox_ruler_set_manual_tick_cnt (arg1, ticks->dims [0]);
   gtk_databox_ruler_set_manual_tick_labels(arg1, ticks->data);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (92, 92, 0);
}

static void sl_gtk_databox_ruler_get_manual_tick_labels (void)
{
   gchar **retval;
   GtkDataboxRuler* arg1;
   Slirp_Opaque* arg1_o = NULL;
   SLang_Array_Type *ticks;
   SLindex_Type n;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;
   
   n = gtk_databox_ruler_get_manual_tick_cnt (arg1);
   retval = gtk_databox_ruler_get_manual_tick_labels(arg1);
   ticks = SLang_create_array (SLANG_STRING_TYPE, 0, retval, &n, 1);
   if (ticks == NULL)
     return;
   (void)SLang_push_array(ticks, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (93, 93, 0);
}

/* end wrapper functions */

static SLang_Intrin_Fun_Type gtkdatabox_Funcs [] =
{
   MAKE_INTRINSIC_0((char*)"gtk_databox_get_ruler_x",sl_gtk_databox_get_ruler_x,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_get_enable_zoom",sl_gtk_databox_get_enable_zoom,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_graph_get_hide",sl_gtk_databox_graph_get_hide,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_graph_get_gc",sl_gtk_databox_graph_get_gc,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_set_scale_type_y",sl_gtk_databox_set_scale_type_y,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_grid_set_vlines",sl_gtk_databox_grid_set_vlines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_get_visible_limits",sl_gtk_databox_get_visible_limits,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_cross_simple_new",sl_gtk_databox_cross_simple_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_create_box_with_scrollbars_and_rulers",sl_gtk_databox_create_box_with_scrollbars_and_rulers,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_set_adjustment_y",sl_gtk_databox_set_adjustment_y,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_grid_array_new",sl_gtk_databox_grid_array_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_set_range",sl_gtk_databox_ruler_set_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_value_to_pixel_x",sl_gtk_databox_value_to_pixel_x,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_get_enable_selection",sl_gtk_databox_get_enable_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_graph_get_size",sl_gtk_databox_graph_get_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_set_enable_zoom",sl_gtk_databox_set_enable_zoom,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_graph_get_color",sl_gtk_databox_graph_get_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_set_visible_limits",sl_gtk_databox_set_visible_limits,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_value_to_pixel_y",sl_gtk_databox_value_to_pixel_y,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_graph_calculate_extrema",sl_gtk_databox_graph_calculate_extrema,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_zoom_out",sl_gtk_databox_zoom_out,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_pixel_to_value_x",sl_gtk_databox_pixel_to_value_x,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_graph_remove_all",sl_gtk_databox_graph_remove_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_get_scale_type_x",sl_gtk_databox_get_scale_type_x,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_new",sl_gtk_databox_ruler_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_grid_get_vlines",sl_gtk_databox_grid_get_vlines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_grid_new",sl_gtk_databox_grid_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_auto_rescale",sl_gtk_databox_auto_rescale,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_set_orientation",sl_gtk_databox_ruler_set_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_set_ruler_y",sl_gtk_databox_set_ruler_y,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_pixel_to_value_y",sl_gtk_databox_pixel_to_value_y,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_markers_set_label",sl_gtk_databox_markers_set_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_get_range",sl_gtk_databox_ruler_get_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_get_adjustment_x",sl_gtk_databox_get_adjustment_x,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_zoom_to_selection",sl_gtk_databox_zoom_to_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_create_box_with_scrollbars_and_rulers_positioned",sl_gtk_databox_create_box_with_scrollbars_and_rulers_positioned,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_set_max_length",sl_gtk_databox_ruler_set_max_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_get_scale_type",sl_gtk_databox_ruler_get_scale_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_set_enable_selection",sl_gtk_databox_set_enable_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_set_adjustment_x",sl_gtk_databox_set_adjustment_x,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_graph_add",sl_gtk_databox_graph_add,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_graph_set_color",sl_gtk_databox_graph_set_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_grid_set_hlines",sl_gtk_databox_grid_set_hlines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_markers_set_position",sl_gtk_databox_markers_set_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_calculate_extrema",sl_gtk_databox_calculate_extrema,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_get_total_limits",sl_gtk_databox_get_total_limits,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_get_max_length",sl_gtk_databox_ruler_get_max_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_get_orientation",sl_gtk_databox_ruler_get_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_markers_new",sl_gtk_databox_markers_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_graph_remove",sl_gtk_databox_graph_remove,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_graph_set_hide",sl_gtk_databox_graph_set_hide,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_set_scale_type",sl_gtk_databox_ruler_set_scale_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_new",sl_gtk_databox_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_get_adjustment_y",sl_gtk_databox_get_adjustment_y,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_get_ruler_y",sl_gtk_databox_get_ruler_y,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_grid_get_hlines",sl_gtk_databox_grid_get_hlines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_zoom_home",sl_gtk_databox_zoom_home,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_set_ruler_x",sl_gtk_databox_set_ruler_x,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_graph_set_gc",sl_gtk_databox_graph_set_gc,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_set_scale_type_x",sl_gtk_databox_set_scale_type_x,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_graph_set_size",sl_gtk_databox_graph_set_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_get_scale_type_y",sl_gtk_databox_get_scale_type_y,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_set_total_limits",sl_gtk_databox_set_total_limits,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_bars_new",sl_gtk_databox_bars_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_lines_new",sl_gtk_databox_lines_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_points_new",sl_gtk_databox_points_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_graph_add_front",sl_gtk_databox_graph_add_front,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_set_box_shadow",sl_gtk_databox_set_box_shadow,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_get_box_shadow",sl_gtk_databox_get_box_shadow,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_set_text_orientation",sl_gtk_databox_ruler_set_text_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_get_text_orientation",sl_gtk_databox_ruler_get_text_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_set_text_alignment",sl_gtk_databox_ruler_set_text_alignment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_get_text_alignment",sl_gtk_databox_ruler_get_text_alignment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_set_draw_ticks",sl_gtk_databox_ruler_set_draw_ticks,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_get_draw_ticks",sl_gtk_databox_ruler_get_draw_ticks,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_set_draw_position",sl_gtk_databox_ruler_set_draw_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_get_draw_position",sl_gtk_databox_ruler_get_draw_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_set_draw_subticks",sl_gtk_databox_ruler_set_draw_subticks,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_get_draw_subticks",sl_gtk_databox_ruler_get_draw_subticks,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_set_text_hoffset",sl_gtk_databox_ruler_set_text_hoffset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_get_text_hoffset",sl_gtk_databox_ruler_get_text_hoffset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_set_invert_edge",sl_gtk_databox_ruler_set_invert_edge,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_get_invert_edge",sl_gtk_databox_ruler_get_invert_edge,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_set_linear_label_format",sl_gtk_databox_ruler_set_linear_label_format,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_get_linear_label_format",sl_gtk_databox_ruler_get_linear_label_format,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_set_log_label_format",sl_gtk_databox_ruler_set_log_label_format,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_get_log_label_format",sl_gtk_databox_ruler_get_log_label_format,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_regions_new",sl_gtk_databox_regions_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_offset_bars_new",sl_gtk_databox_offset_bars_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_set_box_shadow",sl_gtk_databox_ruler_set_box_shadow,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_get_box_shadow",sl_gtk_databox_ruler_get_box_shadow,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_set_manual_ticks",sl_gtk_databox_ruler_set_manual_ticks,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_get_manual_ticks",sl_gtk_databox_ruler_get_manual_ticks,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_set_manual_tick_labels",sl_gtk_databox_ruler_set_manual_tick_labels,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_databox_ruler_get_manual_tick_labels",sl_gtk_databox_ruler_get_manual_tick_labels,SLANG_VOID_TYPE),   
   SLANG_END_INTRIN_FUN_TABLE
};   /* }}} */

static const char* usage_strings[] = { /* {{{ */
   "GtkWidget = gtk_databox_get_ruler_x(GtkWidget)",
   "int = gtk_databox_get_enable_zoom(GtkWidget)",
   "int = gtk_databox_graph_get_hide(GtkOpaque)",
   "GdkGC = gtk_databox_graph_get_gc(GtkOpaque)",
   "gtk_databox_set_scale_type_y(GtkWidget,int)",
   "gtk_databox_grid_set_vlines(GtkOpaque,int)",
   "float, float, float, float = gtk_databox_get_visible_limits(GtkWidget)",
   "GtkOpaque = gtk_databox_cross_simple_new(struct,uint)",
   "gtk_databox_create_box_with_scrollbars_and_rulers(GtkWidget[],GtkWidget[],int,int,int,int)",
   "gtk_databox_set_adjustment_y(GtkWidget,GtkAdjustment)",
   "GtkOpaque = gtk_databox_grid_array_new(int,int,float[],float[],struct,uint)",
   "gtk_databox_ruler_set_range(GtkWidget,double,double,double)",
   "short = gtk_databox_value_to_pixel_x(GtkWidget,float)",
   "int = gtk_databox_get_enable_selection(GtkWidget)",
   "int = gtk_databox_graph_get_size(GtkOpaque)",
   "gtk_databox_set_enable_zoom(GtkWidget,int)",
   "struct = gtk_databox_graph_get_color(GtkOpaque)",
   "gtk_databox_set_visible_limits(GtkWidget,float,float,float,float)",
   "short = gtk_databox_value_to_pixel_y(GtkWidget,float)",
   "float = gtk_databox_graph_calculate_extrema(GtkOpaque)",
   "gtk_databox_zoom_out(GtkWidget)",
   "float = gtk_databox_pixel_to_value_x(GtkWidget,short)",
   "gtk_databox_graph_remove_all(GtkWidget)",
   "int = gtk_databox_get_scale_type_x(GtkWidget)",
   "GtkWidget = gtk_databox_ruler_new(int)",
   "int = gtk_databox_grid_get_vlines(GtkOpaque)",
   "GtkOpaque = gtk_databox_grid_new(int,int,struct,uint)",
   "gtk_databox_auto_rescale(GtkWidget,float)",
   "gtk_databox_ruler_set_orientation(GtkWidget,int)",
   "gtk_databox_set_ruler_y(GtkWidget,GtkWidget)",
   "float = gtk_databox_pixel_to_value_y(GtkWidget,short)",
   "gtk_databox_markers_set_label(GtkOpaque,uint,int,string,int)",
   "double, double, double = gtk_databox_ruler_get_range(GtkWidget)",
   "GtkAdjustment = gtk_databox_get_adjustment_x(GtkWidget)",
   "gtk_databox_zoom_to_selection(GtkWidget)",
   "gtk_databox_create_box_with_scrollbars_and_rulers_positioned(GtkWidget[],GtkWidget[],int,int,int,int,int,int)",
   "gtk_databox_ruler_set_max_length(GtkWidget,uint)",
   "int = gtk_databox_ruler_get_scale_type(GtkWidget)",
   "gtk_databox_set_enable_selection(GtkWidget,int)",
   "gtk_databox_set_adjustment_x(GtkWidget,GtkAdjustment)",
   "int = gtk_databox_graph_add(GtkWidget,GtkOpaque)",
   "gtk_databox_graph_set_color(GtkOpaque,struct)",
   "gtk_databox_grid_set_hlines(GtkOpaque,int)",
   "gtk_databox_markers_set_position(GtkOpaque,uint,int)",
   "float, float, float, float = gtk_databox_calculate_extrema(GtkWidget)",
   "float, float, float, float = gtk_databox_get_total_limits(GtkWidget)",
   "uint = gtk_databox_ruler_get_max_length(GtkWidget)",
   "int = gtk_databox_ruler_get_orientation(GtkWidget)",
   "GtkOpaque = gtk_databox_markers_new(float[],float[],struct,uint,int)",
   "gtk_databox_graph_remove(GtkWidget,GtkOpaque)",
   "gtk_databox_graph_set_hide(GtkOpaque,int)",
   "gtk_databox_ruler_set_scale_type(GtkWidget,uint)",
   "GtkWidget = gtk_databox_new()",
   "GtkAdjustment = gtk_databox_get_adjustment_y(GtkWidget)",
   "GtkWidget = gtk_databox_get_ruler_y(GtkWidget)",
   "int = gtk_databox_grid_get_hlines(GtkOpaque)",
   "gtk_databox_zoom_home(GtkWidget)",
   "gtk_databox_set_ruler_x(GtkWidget,GtkWidget)",
   "gtk_databox_graph_set_gc(GtkOpaque,GdkGC)",
   "gtk_databox_set_scale_type_x(GtkWidget,int)",
   "gtk_databox_graph_set_size(GtkOpaque,int)",
   "int = gtk_databox_get_scale_type_y(GtkWidget)",
   "gtk_databox_set_total_limits(GtkWidget,float,float,float,float)",
   "GtkOpaque = gtk_databox_bars_new(float[],float[],struct,int)",
   "GtkOpaque = gtk_databox_lines_new(float[],float[],struct,int)",
   "GtkOpaque = gtk_databox_points_new(float[],float[],struct,int)",
   "int = gtk_databox_graph_add_front(GtkWidget,GtkOpaque)",
   "gtk_databox_set_box_shadow (GtkWidget, GtkShadowType)",
   "GtkShadowType = gtk_databox_get_box_shadow (GtkWidget)",
   "gtk_databox_ruler_set_text_orientation (GtkWidget, GtkOrientation)",
   "GtkOrientation = gtk_databox_ruler_get_text_orientation (GtkWidget)",
   "gtk_databox_ruler_set_text_alignment (GtkWidget, GtkOrientation)",
   "GtkOrientation = gtk_databox_ruler_get_text_alignment (GtkWidget)",
   "gtk_databox_ruler_set_draw_ticks (GtkWidget, int)",
   "int = gtk_databox_ruler_get_draw_ticks (GtkWidget)",
   "gtk_databox_ruler_set_draw_position (GtkWidget, int)",
   "int = gtk_databox_ruler_get_draw_position (GtkWidget)",
   "gtk_databox_ruler_set_draw_subticks (GtkWidget, int)",
   "int = gtk_databox_ruler_get_draw_subticks (GtkWidget)",
   "sl_gtk_databox_ruler_set_text_hoffset (GtkWidget, int)",
   "int = sl_gtk_databox_ruler_get_text_hoffset (GtkWidget)",
   "sl_gtk_databox_ruler_set_invert_edge (GtkWidget, int)",
   "int = sl_gtk_databox_ruler_get_invert_edge (GtkWidget)",      
   "sl_gtk_databox_ruler_set_linear_label_format (GtkWidget, string)",
   "string = sl_gtk_databox_ruler_get_linear_label_format (GtkWidget)",      
   "sl_gtk_databox_ruler_set_log_label_format (GtkWidget, string)",
   "string = sl_gtk_databox_ruler_get_log_label_format (GtkWidget)",         
   "GtkOpaque = gtk_databox_regions_new(float[],float[],float[],struct,int)",
   "GtkOpaque = gtk_databox_offset_bars_new(float[],float[],float[],struct,int)",
   "sl_gtk_databox_ruler_set_box_shadow (GtkWidget, GtkShadowType)",
   "GtkShadowType = sl_gtk_databox_ruler_get_box_shadow (GtkWidget)",
   "sl_gtk_databox_ruler_set_manual_ticks (GtkWidget, float [])",
   "float [] = sl_gtk_databox_ruler_get_manual_ticks (GtkWidget)",
   "sl_gtk_databox_ruler_set_manual_tick_labels (GtkWidget, string [])",
   "string [] = sl_gtk_databox_ruler_get_manual_tick_labels (GtkWidget)",   
NULL
}; /* }}} */

static void Slirp_usage(int i, int last, int flags) /* {{{ */
{
   char *indent;
   int npop = SLstack_depth();
   if (npop > SLang_Num_Function_Args) npop = SLang_Num_Function_Args;
   SLdo_pop_n(npop);
   if (last == i)
	indent = (char*)"Usage:  ";
   else {
	indent = (char*)"\t";
	SLang_verror(SL_USAGE_ERROR, (char*)"Usage: one of");
   }
   do
	SLang_verror(SL_USAGE_ERROR, (char*)"%s%s", indent, usage_strings[i++]);
   while (i < last);
   if (flags & 0x2)
	SLang_verror(SL_USAGE_ERROR,
		(char*)"\tThis function has been vectorized and parallelized.");
   else if (flags & 0x1)
	SLang_verror(SL_USAGE_ERROR, (char*)"\tThis function has been vectorized.");
} /* }}} */

static SLang_IConstant_Type gtkdatabox_IConsts [] =	/* {{{ */
{
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_SOLID_LINE",GTK_DATABOX_MARKERS_SOLID_LINE),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_TEXT_CENTER",GTK_DATABOX_MARKERS_TEXT_CENTER),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_NONE",GTK_DATABOX_MARKERS_NONE),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_TEXT_NW",GTK_DATABOX_MARKERS_TEXT_NW),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_TEXT_N",GTK_DATABOX_MARKERS_TEXT_N),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_TEXT_SE",GTK_DATABOX_MARKERS_TEXT_SE),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_SCALE_LOG2",GTK_DATABOX_SCALE_LOG2),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_TRIANGLE",GTK_DATABOX_MARKERS_TRIANGLE),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_TEXT_NE",GTK_DATABOX_MARKERS_TEXT_NE),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_DASHED_LINE",GTK_DATABOX_MARKERS_DASHED_LINE),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_SCALE_LINEAR",GTK_DATABOX_SCALE_LINEAR),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_C",GTK_DATABOX_MARKERS_C),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_SCALE_LOG",GTK_DATABOX_SCALE_LOG),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_E",GTK_DATABOX_MARKERS_E),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_TEXT_W",GTK_DATABOX_MARKERS_TEXT_W),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_N",GTK_DATABOX_MARKERS_N),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_S",GTK_DATABOX_MARKERS_S),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_TEXT_S",GTK_DATABOX_MARKERS_TEXT_S),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_TEXT_SW",GTK_DATABOX_MARKERS_TEXT_SW),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_TEXT_E",GTK_DATABOX_MARKERS_TEXT_E),
   MAKE_ICONSTANT((char*)"GTK_DATABOX_MARKERS_W",GTK_DATABOX_MARKERS_W),
   SLANG_END_ICONST_TABLE
};	/* }}} */

#define SLIRP_VERSION_STRING pre2.0.0-24
#define SLIRP_VERSION_NUMBER 20000
SLANG_MODULE(gtkdatabox);
int init_gtkdatabox_module_ns(char *ns_name)	/* {{{ */
{
   SLang_NameSpace_Type *ns = NULL;

   if (slang_abi_mismatch()) return -1;
   if (ns_name != NULL) {
	ns = SLns_create_namespace (ns_name);
       if (ns == NULL ||
          (slns = SLmalloc(strlen(ns_name)+1)) == NULL)
          return -1;
       strcpy(slns, ns_name);
   }

   (void) &ref_get_size; /* avoid compile warn if unused */

   if (allocate_reserved_opaque_types() == -1) return -1;
#ifdef HAVE_OPAQUE_IVARS
   if (-1 == set_opaque_ivar_types(gtkdatabox_Opaque_IVars) ||
       -1 == SLns_add_intrin_var_table(ns,gtkdatabox_Opaque_IVars,NULL))
	return -1;
#endif

   if ( -1 == SLns_add_iconstant_table(ns,gtkdatabox_IConsts,NULL) ||
	-1 == SLns_add_intrin_fun_table (ns,gtkdatabox_Funcs,(char*)"__gtkdatabox__"))
	return -1;

   return 0;
} /* }}} */
